<!DOCTYPE html>
<html>
    <head>
        <script src="/socket.io/socket.io.js"></script>
        <script>
            var signaling_socket = null;
            var local_media_stream = null;
            var USE_AUDIO = true;
            var USE_VIDEO = true;
            var ICE_SERVERS = [
                {urls:"stun:stun.l.google.com:19302"}
            ];

            function init() {
                var signaling_socket = io();

                signaling_socket.on('connect', function() {
                    console.log('Connected to signaling server');
                    setup_local_media(function() {
                        console.log('Media setuped');
                    })
                });
            }

            function createPeer() {
                
            }

            function setup_local_media(callback, errorback) {
                if (local_media_stream != null) {  /* ie, if we've already been initialized */
                    if (callback) callback();
                    return; 
                }
                /* Ask user for permission to use the computers microphone and/or camera, 
                 * attach it to an <audio> or <video> tag if they give us access. */
                console.log("Requesting access to local audio / video inputs");


                navigator.getUserMedia = ( navigator.getUserMedia ||
                       navigator.webkitGetUserMedia ||
                       navigator.mozGetUserMedia ||
                       navigator.msGetUserMedia);

                attachMediaStream = function(element, stream) {
                    console.log('DEPRECATED, attachMediaStream will soon be removed.');
                    element.srcObject = stream;
                 };

                navigator.mediaDevices.getUserMedia({"audio":USE_AUDIO, "video":USE_VIDEO})
                    .then(function(stream) { /* user accepted access to a/v */
                        console.log("Access granted to audio/video");
                        local_media_stream = stream;
                        var local_media = USE_VIDEO ? $("<video>") : $("<audio>");
                        local_media.attr("autoplay", "autoplay");
                        local_media.attr("muted", "true"); /* always mute ourselves by default */
                        local_media.attr("controls", "");
                        $('body').append(local_media);
                        attachMediaStream(local_media[0], stream);

                        if (callback) callback();
                    })
                    .catch(function() { /* user denied access to a/v */
                        console.log("Access denied for audio/video");
                        alert("You chose not to provide access to the camera/microphone, demo will not work.");
                        if (errorback) errorback();
                    })
            }
        </script>
    </head>
    <body onload='init()'>

    </body>
</html>